	.section ".text"
        .align
        .code 32

        .global start
start:
/*****************************************************************************/

	b	rom_header_end

/*****************************************************************************/

	/* Nintendo Logo Character Data (8000004h) */
	.fill	156,1,0

	/* Game Title (80000A0h) */
	.byte	0x00,0x00,0x00,0x00
        .byte   0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00

	/* Game Code (80000ACh) */
	.byte	0x00,0x00,0x00,0x00

	/* Maker Code (80000B0h) */
	.byte	0x30,0x31

	/* Fixed Value (80000B2h) */
	.byte	0x96

	/* Main Unit Code (80000B3h) */
	.byte	0x00

	/* Device Type (80000B4h) */
	.byte	0x00

	/* Unused Data (7Byte) (80000B5h) */
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00

	/* Software Version No (80000BCh) */
	.byte	0x00

	/* Complement Check (80000BDh) */
	.byte	0xf0

	/* Reserved (80000BEh) */
	.byte	0x00,0x00

rom_header_end:

/*****************************************************************************/

	b	start_vector

/*****************************************************************************/

	.byte	0	/* boot method (0=ROM boot, 3=Multiplay boot) */
	.byte	0	/* slave # (1=slave#1, 2=slave#2, 3=slave#3) */
	.byte	0
	.byte	0
	.word	0
	.word	0
	.word	0
	.word	0
	.word	0
	.word	0

/*****************************************************************************/

start_vector:

init_cpsr:
        mov	r0,#0xD0 /* disable irq fiq, usr mode */
	msr	cpsr,r0

init_stack:
        ldr	sp,=__stack /* setup usr stack */
        
init_data:
	ldr	r0, =__lma_data_beg
	ldr	r1, =__vma_data_beg
	ldr	r2, =__vma_data_end
	cmp     r1, r2
	bcs     init_data_end
init_data_loop: 
	ldmia   r0!, {r3}
	stmia   r1!, {r3}
	cmp     r1, r2
	bcc     init_data_loop
init_data_end:  

init_bss:
	mov     r0, #0
	ldr	r1, =__vma_bss_beg
	ldr	r2, =__vma_bss_end
	cmp     r1, r2
	bcs     init_bss_end
init_bss_loop: 
	stmia   r1!, {r0}
	cmp     r1, r2
	bcc     init_bss_loop
init_bss_end:   

call_main:
        ldr	r0,=main + 1 /* call main + set bit 1 for thumb call */
        mov     lr,pc       /* load link register with PC (this address + 8) */
        bx	r0

end_vector:
        b end_vector
        